﻿//////////////////////////////////////////////
// Window.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class MenuBar ;
}

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT Window : public Component
	{
		protected :

			// Functions
			// Allocations
			virtual MenuBar* _allocateMenuBar () const = 0 ;

		protected :
		
			// Attributes
			// Le menu s'il y a
			MenuBar* _menuBar ;

			// Variables pour l'init
			bool _showOnStartup ;
		
		public :
		
			// Constructeur, destructeur
			Window () ;
			~Window () ;

			// Getters
			MenuBar* getMenuBar () const ;

			// Setters
			virtual MenuBar* attachMenuBar () ;

			// Maximisation
			virtual void maximize (bool val) = 0 ;

			// Setters
			void setShowOnStartup (bool value) ;

			// Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}