//////////////////////////////////////////////
// StructToString.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	enum class RELATIVE_POSITION ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Components/ComponentType.h"

#include "../Layouts/LayoutType.h"

// Standards
#include <string>

/// Class ------------------------------------

namespace nkWinUi
{
	class StructToString
	{
		private :

			// Functions
			// Constructeur, destructeur
			StructToString () = delete ;
			~StructToString () = delete ;

		public :

			// Components
			static const char* getStringFromComponentType (COMPONENT_TYPE type) ;
			static COMPONENT_TYPE getComponentTypeFromString (const std::string_view& name) ;

			// Layouts
			static const char* getStringFromLayoutType (LAYOUT_TYPE type) ;
			static LAYOUT_TYPE getLayoutTypeFromString (const std::string_view& name) ;

			// Relative position
			static const char* getStringFromRelativePosition (RELATIVE_POSITION position) ;
			static RELATIVE_POSITION getRelativePositionFromString (const std::string_view& name) ;

			/*const char* getStringFromAlignment (ALIGNMENT type) ;
			ALIGNMENT getAlignmentFromString (const char* name) ;*/
	} ;
}